/*
  $Id: main.js,v 1.1.1.1 2006/03/16 14:49:55 StasFomin Exp $
*/
var TextAreaSputnik = {
    _preferences: null,

  init: function() {
    var prefs_ = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    TextAreaSputnik._preferences = prefs_.getBranch("extensions.TextAreaSputnik.");

    var menu = document.getElementById("contentAreaContextMenu");
		if (menu) {
      menu.addEventListener("popupshowing", 
                function() {
                  if (gContextMenu) {
                    gContextMenu.showItem("textareasputnik_menu_edit", gContextMenu.onTextInput);
                }} , false);
    }
    getBrowser().addEventListener("mousedown", TextAreaSputnik.evtMouseDown, true);
	},

  evtEditTextarea: function() {
    var file_ = this.textarea2file(gContextMenu.target);
    if (file_.exists()) file_.remove(false);
    file_.create(file_.NORMAL_FILE_TYPE, 0600);


		var textBoxText = gContextMenu.target.value;
    if (this.isDosNewline) {
			textBoxText = textBoxText.replace(/\n/g, "\r\n");
		}
    var converter = this.getConverter();
    var chunk = converter.ConvertFromUnicode(textBoxText);

    var ostr = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
    ostr.init(file_, 2, 0x200, false);
		ostr.write(chunk, chunk.length);
		ostr.flush();
		ostr.close();

    var editor_ = this._preferences.getCharPref("editor");
    if (!editor_) {
      alert("Please, set absolute path to an editor in the options!");
      return;
		}

    var editorFile_ = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    editorFile_.initWithPath(editor_);
    if (!editorFile_.exists()) {
      alert("Editor '" + editorFile_.path + "' not found!");
      return;
		}

    if (!editorFile_.isExecutable()) {
      alert("File '" + editorFile_.path + "' is not executable!");
      return;
		}

		var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
    process.init(editorFile_);
    var args = [file_.path];
    process.run(false, args, args.length);
    return;
  },

  evtMouseDown: function(evt) {
      for(var node = evt.originalTarget; node != null; node = node.parentNode) {
          if(node.nodeType == Node.ELEMENT_NODE) {
                  if (node.localName.toUpperCase() == "TEXTAREA") {
                        var file_ = TextAreaSputnik.textarea2file(node);
                        if (!file_.exists()) return;
                        var converter = TextAreaSputnik.getConverter();
                        var istr = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
                        var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
                        istr.init(file_, 1, 0x400, false);
                        sstream.init(istr);
                        var text_to_load = sstream.read(-1);
                        node.value = converter.ConvertToUnicode(text_to_load);
                        sstream.close();
                        istr.close();
                        if (evt.button == 0) {
                          file_.remove(false);
                        };
                        break;
                  }
              
          }
      }
  },

  getTmpDir: function() {
    var dirService_ = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
    return dirService_.get("UChrm", Components.interfaces.nsILocalFile).path;
  },

  getExt:  function() {
    var ext_ = this._preferences.getCharPref("extension");
    if (!ext_) ext_="txt";
    return ext_;
  },

  isDosNewline:  function() {
    return (this._preferences.getCharPref("dosnewline")=="1");
  },



  getEncoding:  function() {
    var encoding_ = this._preferences.getCharPref("encoding");
    if (!encoding_) encoding_='UTF-8';
    return encoding_;
  },

  getConverter:  function() {
		var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    converter.charset = this.getEncoding();
    return converter;
  },

  textarea2file: function(textarea_node) {
    var tmpdir_ = this.getTmpDir();
    if (!tmpdir_) return null;
    var file_ = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    file_.initWithPath(tmpdir_);
    file_.appendRelativePath("exteditor-textarea-" +  
        hex_md5(textarea_node.ownerDocument.URL + ':' + textarea_node.getAttribute("name")) + "." + this.getExt());
    return file_;
  }
};
